@view-transition {
  navigation: auto;
}

::view-transition-group(root) {
  animation-duration: 1s;
}

@layer reset {
  *,
  *::before,
  *::after {
    box-sizing: border-box;
  }

  /* https://kilianvalkhof.com/2022/css-html/your-css-reset-needs-text-size-adjust-probably/ */
  html {
    -moz-text-size-adjust: none;
    -webkit-text-size-adjust: none;
    text-size-adjust: none;
  }

  body,
  h1,
  h2,
  h3,
  h4,
  p,
  figure,
  blockquote,
  dl,
  dd {
    margin: 0;
  }

  /* https://www.scottohara.me/blog/2019/01/12/lists-and-safari.html */
  [role="list"] {
    list-style: none;
    margin: 0;
    padding: 0;
  }

  body {
    min-block-size: 100vh;
    line-height: 1.6;
  }

  h1,
  h2,
  h3,
  button,
  input,
  label {
    line-height: 1.1;
  }

  h1,
  h2,
  h3,
  h4 {
    text-wrap: balance;
  }

  p,
  li {
    text-wrap: pretty;
  }

  img,
  picture {
    max-inline-size: 100%;
    display: block;
  }

  input,
  button,
  textarea,
  select {
    font: inherit;
  }
}

@layer base {
  :root {
    --breakpoint-sm: 720px;
    --breakpoint-md: 1130px;
    --breakpoint-lg: 1330px;

    --clr-white: hsl(0, 0%, 100%);
    --clr-black: hsl(0, 0%, 0%);
    --clr-gray-100: hsl(0, 2%, 79%);
    --clr-gray-900: hsl(0, 2%, 10%);
    --clr-brand-400: hsl(25, 88%, 75%);
    --clr-brand-500: hsl(25, 88%, 66%);
    --clr-green-100: hsl(143, 19%, 90%);
    --clr-green-200: hsl(143, 19%, 75%);
    --clr-green-300: hsl(143, 19%, 60%);
    --clr-green-400: hsl(143, 19%, 49%);
    --clr-green-500: hsl(143, 38%, 37%);
    --clr-green-600: hsl(145, 29%, 19%);
    --clr-brown-100: hsl(10, 5%, 90%);
    --clr-brown-200: hsl(10, 5%, 80%);
    --clr-brown-300: hsl(10, 5%, 65%);
    --clr-brown-400: hsl(10, 5%, 45%);
    --clr-brown-500: hsl(10, 5%, 25%);
    --clr-brown-600: hsl(9, 7%, 21%);
    --clr-brown-700: hsl(9, 8%, 16%);
    --clr-brown-800: hsl(0, 6%, 15%);
    --clr-brown-900: hsl(0, 6%, 13%);
    --clr-orange-500: hsl(28, 43%, 28%);
    --clr-red-300: hsl(359, 34%, 44%);
    --clr-red-500: hsl(359, 34%, 24%);
    --clr-teal-500: hsl(186, 42%, 25%);

    --ff-heading: "Outfit", sans-serif;
    --ff-body: "Fira Sans", sans-serif;

    --fs-300: 0.875rem;
    --fs-400: 1rem;
    --fs-500: 1.125rem;
    --fs-600: 1.25rem;
    --fs-700: 1.5rem;
    --fs-800: 2rem;
    --fs-900: 3.75rem;
    --fs-1000: 3.75rem;

    @media (width > 720px) {
      --fs-300: 0.875rem;
      --fs-400: 1rem;
      --fs-500: 1.25rem;
      --fs-600: 1.5rem;
      --fs-700: 2rem;
      --fs-800: 3rem;
      --fs-900: 5rem;
      --fs-1000: 7.5rem;
    }
  }

  :root {
    --text-main: var(--clr-gray-100);
    --text-high-contrast: var(--clr-white);
    --text-brand: var(--clr-brand-500);
    --text-brand-light: var(--clr-brand-400);

    --background-accent-light: var(--clr-green-400);
    --background-accent-main: var(--clr-green-500);
    --background-accent-dark: var(--clr-green-600);

    --background-extra-light: var(--clr-brown-500);
    --background-light: var(--clr-brown-600);
    --background-main: var(--clr-brown-700);
    --background-dark: var(--clr-brown-800);
    --background-extra-dark: var(--clr-brown-900);

    --font-size-heading-sm: var(--fs-700);
    --font-size-heading-regular: var(--fs-800);
    --font-size-heading-lg: var(--fs-900);
    --font-size-heading-xl: var(--fs-1000);

    --font-size-sm: var(--fs-300);
    --font-size-regular: var(--fs-400);
    --font-size-md: var(--fs-500);
    --font-size-lg: var(--fs-600);

    --border-radius-1: 0.25rem;
    --border-radius-2: 0.5rem;
    --border-radius-3: 0.75rem;

    @media (prefers-color-scheme: light) {
      --text-main: var(--clr-gray-900);
      --text-high-contrast: var(--clr-black);
      --text-brand: var(--clr-brand-500);
      --text-brand-light: var(--clr-brand-400);

      --background-accent-light: var(--clr-green-100);
      --background-accent-main: var(--clr-green-200);
      --background-accent-dark: var(--clr-green-300);

      --background-extra-light: var(--clr-brown-500);
      --background-light: var(--clr-brown-400);
      --background-main: var(--clr-brown-300);
      --background-dark: var(--clr-brown-200);
      --background-extra-dark: var(--clr-brown-100);
    }
  }

  [data-theme="light"] {
    color-scheme: light;
  }

  @media (prefers-reduced-motion: no-preference) {
    html {
      scroll-behavior: smooth;
      transition-behavior: allow-discrete;
    }
  }

  html {
    font-family: var(--ff-body);
    line-height: 1.6;
    scroll-padding: 1rem;
  }

  body {
    font-size: var(--font-size-regular);
    color: var(--text-main);
    background-color: var(--background-main);
  }

  h1,
  h2,
  h3,
  h4 {
    font-family: var(--ff-heading);
    font-weight: 700;
    color: var(--text-high-contrast);
  }

  h1 {
    font-size: var(--font-size-heading-lg);
  }
  h2 {
    font-size: var(--font-size-heading-regular);
  }

  h1 > span,
  h2 > span,
  h3 > span,
  h4 > span {
    color: var(--text-brand);
  }

  a {
    color: var(--text-high-contrast);
  }
  a:hover,
  a:focus-visible {
    color: var(--text-brand-light);
  }
  img {
    border-radius: var(--border-radius-3);
  }
}

@layer layout {
  body {
    display: grid;
    grid-template-rows: auto 1fr auto;
  }

  .container {
    --container-max-width: var(--breakpoint-md);
    max-inline-size: var(--container-max-width);
    margin-inline: auto;
    padding-inline: 1rem;

    &[data-width="wide"] {
      --container-max-width: var(--breakpoint-lg);
    }

    &[data-width="narrow"] {
      --container-max-width: var(--breakpoint-sm);
    }
  }

  main > section {
    --section-block-padding: 3.75rem;
    padding-block: var(--section-block-padding);
    @media (width > 720px) {
      --section-block-padding: 8rem;
    }
    &h2 {
      font-size: var(--font-size-heading-regular);
    }
  }

  .flex-group {
    display: flex;
    gap: 1rem;
    align-items: center;
    justify-content: flex-start;
    flex-wrap: wrap;
  }

  .grid {
    --column-count: 1;

    display: grid;
    gap: var(--grid-gap, 1rem);
    grid-template-columns: repeat(var(--column-count), 1fr);

    @media (width > 720px) {
      &[data-cols="2"] {
        --column-count: 2;
      }
      &[data-cols="3"] {
        --column-count: 3;
      }
      &[data-cols="4"] {
        --column-count: 4;
      }
    }
  }

  .grid-auto {
    --min-col-size: 250px;
    --col-size-method: auto-fit;
    display: grid;
    gap: 1rem;
    grid-template-columns: repeat(
      var(--col-size-method),
      minmax(min(var(--min-col-size), 100%), 1fr)
    );
  }

  .equal-columns {
    display: grid;
    gap: var(--grid-gap, 1rem);
    align-items: var(--grid-alignment, stretch);

    &[data-gap="lg"] {
      --grid-gap: 2rem;
    }

    &[data-align="center"] {
      --grid-alignment: center;
    }

    @media (width > 720px) {
      grid-auto-flow: column;
      grid-auto-columns: 1fr;
    }
  }
}

@layer components {
  .skip-navigation {
    text-decoration: none;
    overflow: hidden;
    white-space: nowrap;
    position: absolute;
    border-radius: var(--border-radius-2);
    background-color: var(--background-accent-main);
    padding: 0.5rem 1rem;
    left: 50%;
    top: 0.25rem;
    transform: translateX(-50%);
    color: var(--text-high-contrast);
    &:not(:focus) {
      width: 1px;
      height: 1px;
      clip: rect(0, 0, 0, 0);
      clip-path: inset(50%);
    }
  }

  .site-header {
    color-scheme: dark;
    background-color: var(--background-dark);
    padding-block: 0.5rem;
    position: relative;
    overflow-x: clip;
    img {
      border-radius: 0;
    }
  }
  .site-header > .container {
    display: flex;
    flex-wrap: wrap;
    align-items: center;
    justify-content: space-between;
    gap: 1rem;
  }

  [aria-controls="site-nav"] {
    z-index: 100;
    aspect-ratio: 1;
    background-color: transparent;
    border: none;
    cursor: pointer;
    display: none;
    @media (width < 720px) {
      display: block;
    }
  }

  .site-nav {
    ul {
      display: flex;
      flex-wrap: wrap;
      gap: 1rem;
      align-items: center;
    }
    a {
      text-decoration: none;
      &:hover,
      &:focus-visible {
        text-decoration-line: underline;
        text-decoration-thickness: 0.125rem;
        text-decoration-color: var(--background-accent-light);
        text-underline-offset: 0.5rem;
      }
    }
    @media (width < 720px) {
      background-color: var(--background-accent-main);
      padding: 2rem;
      position: absolute;
      z-index: 10;
      top: 0;
      right: 0;
      font-size: var(--font-size-lg);
      font-weight: 700;
      font-family: var(--ff-heading);
      border-bottom-left-radius: var(--border-radius-3);
      display: none;
      opacity: 0;
      transform: translateX(100%);
      transition: opacity 0.25s, display 0.25s, transform 0.25s;
      transition-behavior: allow-discrete;
      ul {
        flex-direction: column;
        gap: 0;
        align-items: stretch;
        li + li {
          border-top: 2px solid var(--background-accent-light);
          margin-block-start: 2rem;
          padding-block-start: 2rem;
        }
      }
      li {
        --delay: 0.25s;
        opacity: 0;
        transform: translateX(100%);
        transition: opacity 0.25s, transform 0.25s;
        transition-delay: var(--delay);
        transition-behavior: allow-discrete;
        &:nth-child(2) {
          --delay: 0.375s;
        }
        &:nth-child(3) {
          --delay: 0.5s;
        }
      }
    }
  }

  @media (width < 720px) {
    [aria-expanded="true"] ~ .site-nav {
      display: block;
      opacity: 1;
      transform: translateX(0);
      @starting-style {
        display: block;
        opacity: 0;
        transform: translateX(100%);
      }
      li {
        opacity: 1;
        transform: translateX(0);
        @starting-style {
          opacity: 0;
          transform: translateX(100%);
        }
      }
    }
  }

  .site-footer {
    text-align: center;
    padding-block: 2rem;
    background-color: var(--background-accent-dark);
    display: grid;
    gap: 2rem;
    h4 {
      font-size: var(--font-size-md);
    }
    div {
      display: flex;
      gap: 1rem;
      justify-content: center;
      align-items: center;
      @media (width < 720px) {
        flex-direction: column;
      }
    }
  }

  .hero {
    color-scheme: dark;
    background-image: url(../images/hero.webp);
    background-size: cover;
    background-position: center;
    color: var(--text-high-contrast);
    font-size: var(--font-size-md);
    text-align: center;

    h1 span {
      font-size: var(--font-size-heading-xl);
      display: block;
    }
  }

  .card {
    background-color: var(--background-light);
    padding: 1rem;
    border-radius: var(--border-radius-3);
    display: flex;
    flex-direction: column;
    gap: var(--card-gap, 1rem);
    h3 {
      color: var(--card-title-color, var(--text-brand));
      font-size: var(--card-title-font-size, var(--font-size-md));
    }
  }
  .button {
    display: inline-flex;
    text-decoration: none;
    cursor: pointer;
    padding: 0.5rem 1rem;
    border: 0;
    border-radius: var(--border-radius-2);
    background-color: var(--background-accent-dark);
    color: var(--text-high-contrast);
    font-size: var(--font-size-regular);
    font-family: var(--ff-heading);
    &:hover,
    &:focus-visible {
      background-color: var(--background-accent-main);
    }
  }

  select {
    padding: 0.25rem 0.5rem;
    background-color: var(--background-accent-main);
    border: 0;
    border-radius: var(--border-radius-2);
    color: var(--text-high-contrast);
  }

  .mushroom-guide {
    --card-title-color: var(--text-high-contrast);
    --card-title-font-size: var(--font-size-lg);
    --card-gap: 0.75rem;
    --col-size-method: auto-fill;
  }

  .filter-message {
    background-color: var(--background-extra-light);
    padding: 0.5rem 1rem;
    border-radius: var(--border-radius-2);
    font-size: var(--font-size-md);
    color: var(--text-high-contrast);
  }

  /* .mushroom-guide[data-type="edible"] .card:not([data-type="edible"]) {
    display: none;
  }

  .mushroom-guide[data-type="toxic"] .card:not([data-type="toxic"]) {
    display: none;
  }

  .mushroom-guide[data-season="spring"] .card:not([data-season="spring"]) {
    display: none;
  }

  .mushroom-guide[data-season="summer"] .card:not([data-season="summer"]) {
    display: none;
  }

  .mushroom-guide[data-season="fall"] .card:not([data-season="fall"]) {
    display: none;
  } */

  .tags {
    display: flex;
    align-items: center;
    gap: 0.5rem;
    flex-wrap: wrap;

    li {
      background-color: var(--tag-background, var(--background-accent-main));
      font-family: var(--ff-heading);
      font-size: var(--font-size-sm);
      padding: 0.25rem 0.5rem;
      line-height: 1;
      border-radius: var(--border-radius-1);
      color: var(--text-high-contrast);
    }
  }
  .card[data-season="spring"] li:last-of-type {
    --tag-background: var(--clr-teal-500);
  }
  .card[data-season="summer"] li:last-of-type {
    --tag-background: var(--clr-green-500);
  }
  .card[data-season="fall"] li:last-of-type {
    --tag-background: var(--clr-orange-500);
  }
  .card[data-season="winter"] li:last-of-type {
    --tag-background: var(--clr-teal-500);
  }
  .card[data-type="edible"] li:first-of-type {
    --tag-background: var(--clr-green-400);
  }
  .card[data-type="toxic"] li:first-of-type {
    --tag-background: var(--clr-red-300);
  }

  .notes {
    background-color: var(--background-extra-light);
    padding: 0.5rem 0.75rem;
    border-radius: var(--border-radius-2);
    font-size: var(--font-size-sm);
    color: var(--text-main);
    margin-block-start: auto;
  }

  .bento {
    --card-title-color: var(--text-high-contrast);
    --card-title-font-size: var(--font-size-heading-sm);
    display: grid;
    gap: 1rem;
    grid-template-areas:
      "card-one"
      "card-two"
      "card-three"
      "card-four";

    @media (width > 650px) {
      grid-template-areas:
        "card-one card-two"
        "card-three card-four";
    }

    @media (width > 900px) {
      grid-template-areas:
        "card-one card-two card-four"
        "card-three card-three card-four";
    }
    .card > img {
      height: 100%;
      object-fit: cover;
    }

    @media (width > 650px) {
      .card:nth-child(even) > img {
        order: 3;
      }
    }

    @media (width > 900px) {
      .card:nth-child(4) > img {
        order: 0;
      }
    }

    .card:nth-child(1) {
      grid-area: card-one;
    }
    .card:nth-child(2) {
      grid-area: card-two;
    }
    .card:nth-child(3) {
      grid-area: card-three;
      display: grid;
      @media (width > 900px) {
        grid-template-columns: 350px 1fr;
        gap: 1rem;
        align-items: start;
        align-content: start;
        img {
          grid-column: 1 / 2;
          grid-row: 1 / 3;
        }
      }
    }
    .card:nth-child(4) {
      grid-area: card-four;
    }
  }
}

@layer animations {
  @keyframes fade-out {
    from {
      opacity: 1;
    }
    to {
      opacity: 0;
    }
  }
  @keyframes fade-in {
    from {
      opacity: 0;
    }
    to {
      opacity: 1;
    }
  }
}

@layer utilities {
  [hidden] {
    display: none;
  }

  .resizing * {
    animation: none !important;
    transition: none !important;
  }

  .flow > * + * {
    margin-block-start: 1em;
  }

  .visually-hidden,
  .sr-only {
    position: absolute;
    width: 1px;
    height: 1px;
    overflow: hidden;
    clip: rect(0, 0, 0, 0);
    clip-path: inset(50%);
    white-space: nowrap;
  }

  .text-center {
    text-align: center;
  }

  .text-end {
    text-align: end;
  }

  .text-main {
    color: var(--text-main);
  }
  .text-high-contrast {
    color: var(--text-high-contrast);
  }
  .text-brand {
    color: var(--text-brand);
  }
  .text-brand-light {
    color: var(--text-brand-light);
  }

  .bg-accent-light {
    background-color: var(--background-accent-light);
  }
  .bg-accent {
    background-color: var(--background-accent-main);
  }
  .bg-accent-dark {
    background-color: var(--background-accent-dark);
  }

  .bg-extra-light {
    background-color: var(--background-extra-light);
  }
  .bg-light {
    background-color: var(--background-light);
  }
  .bg-main {
    background-color: var(--background-main);
  }
  .bg-dark {
    background-color: var(--background-dark);
  }
  .bg-extra-dark {
    background-color: var(--background-extra-dark);
  }

  .font-size-heading-sm {
    font-size: var(--font-size-heading-sm);
  }
  .font-size-heading-regular {
    font-size: var(--font-size-heading-regular);
  }
  .font-size-heading-lg {
    font-size: var(--font-size-heading-lg);
  }
  .font-size-heading-xl {
    font-size: var(--font-size-heading-xl);
  }

  .font-size-sm {
    font-size: var(--font-size-sm);
  }
  .font-size-regular {
    font-size: var(--font-size-regular);
  }
  .font-size-lg {
    font-size: var(--font-size-lg);
  }
  .font-size-xl {
    font-size: var(--font-size-xl);
  }
}
